/*
    Copyright (C) 2009-2010 Bentejui Medina Clavijo bentejui.mcl(at)ventejuy.es

    This file is part of Femsii.

    Femsii is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Femsii is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Femsii.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "P_sistemaEc.h"
#include <iostream>
#include <string>
#include <math.h>
#include <fstream>
#include <stdlib.h>
#include <string.h>
#define PI 3.14159265358979323846264338327950288419716939937510

using namespace std;


int main(int argc, char** argv)
{
	int verb = 0; // por omision se ocultan las matrices locales
//	cout << "\nMostrar las matridez locales de rigidez ? 0/1: ";
//	if( !(cin >> verb)) cout << "Simbolo desconocido. Castigado!.\n";

// se crea un objeto de la clase Sistema_ecuaciones. Esto ejecutara el constructor.
	Sistema_ecuaciones prueba(argv[1]);



// Se crea el sistema de ecuaciones base para comenzar a trabajar.
	prueba.getStiffness(verb);

// Se puede utilizar lo siguiente para mostrar la matriz global. Cuidado con el tamanhio
//	cout << "\nMostrar la matridez global de rigidez ? 0/1: ";
//	verb=0; cin >> verb; if( verb==1 ){ cout<<"\n Matriz global" << endl; prueba.print_global(); }

// se genera el vector de terminos independientes, la "b" de Ax=b
	prueba.rightSide();

// Se ha prototipado estas funciones para empezar a tabajar con la transformacion de kelvin. Esta caracteristica queda fuera de Femsii 1.0.0
//	prueba.dirichletPto(); // DIRICHLET POR PUNTO	
//	prueba.paresHomologos();
//	prueba.kelvin();

// Se llama a la funcion que crea impone las condiciones dirichlet al sistema de ecuaciones.
	prueba.dirichletLin();
	
// Se crea un archivo binario tipo PETSc para almacenar la matriz creada, y el vectorde terminos independientes. Este archivo lo utilizara femsii_solve.cpp
	prueba.aBinario();

//	cout << "\nMostrar la matridez global de rigidez ? 0/1: ";
//	verb=0; cin >> verb; if( verb==1 ){ cout<<"\n Matriz global" << endl; prueba.print_global(); }

	return 0;
}
